#include "DxLib.h"

// ʂ̃TCY
#define SCREEN_W		1280
#define SCREEN_H		720

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	int ModelHandle ;
	int NormalScreenHandle ;
	int ColorScreenHandle ;
	int OutputScreenHandle ;
	int KernelRadius = 120 ;
	int MinDistance = 4 ;
	int MaxDistance = 10 ;
	int Strength = 8 ;
	int OcclusionPower = 82 ;

	// EChE[hŋN
	ChangeWindowMode( TRUE ) ;

	// ʉ𑜓xݒ
	SetGraphMode( SCREEN_W, SCREEN_H, 32 ) ;

	// cwCȕ
	if( DxLib_Init() < 0 ) return -1 ;

	// Rcf̓ǂݍ
	ModelHandle = MV1LoadModel( "D:/Model/Stage/SSAO_Stage.mqo" ) ;

	// MakeScreen ō쐬 Zobt@̃rbg[x 24bit ɐݒ
	SetCreateDrawValidGraphZBufferBitDepth( 24 ) ;

	// J[obt@̍쐬
	ColorScreenHandle = MakeScreen( SCREEN_W, SCREEN_H, FALSE ) ;

	// @obt@̍쐬
	NormalScreenHandle = MakeScreen( SCREEN_W, SCREEN_H, TRUE ) ;

	// o͐obt@̍쐬
	OutputScreenHandle = MakeScreen( SCREEN_W, SCREEN_H, FALSE ) ;

	// Cg̐ݒ
	SetLightEnable( FALSE ) ;
	SetGlobalAmbientLight( GetColorF( 0.200f, 0.200f, 0.200f, 0.0f ) ) ;

	int Light0Handle = CreatePointLightHandle( VGet( 0.000f, 200.000f, 0.000f ), 2000.000f, 1.000f, 0.000f, 0.000f ) ;
	SetLightDifColorHandle( Light0Handle, GetColorF( 1.000f, 1.000f, 1.000f, 1.000f ) ) ;
	SetLightSpcColorHandle( Light0Handle, GetColorF( 0.500f, 0.500f, 0.500f, 0.000f ) ) ;
	SetLightAmbColorHandle( Light0Handle, GetColorF( 0.000f, 0.000f, 0.000f, 0.000f ) ) ;

	// sNZPʂ̃CeBOs`惂[hɐݒ肷
	SetUsePixelLighting( TRUE ) ;

	// C[v
	while( ProcessMessage() == 0 )
	{
		// J[obt@`Ώ0ɁA@obt@`Ώ1ɐݒ
		SetRenderTargetToShader( 0, ColorScreenHandle ) ;
		SetRenderTargetToShader( 1, NormalScreenHandle ) ;

		// Jݒ
		SetCameraPositionAndTarget_UpVecY( VGet( 0.0f, 0.0f, -550.0f ), VGet( 0.000000f, 0.000000f, 0.000000f ) );
		SetCameraNearFar( 12.000000f, 3000.000000f );

		// ʂ̃NA
		ClearDrawScreen() ;

		// f̕`
		MV1DrawModel( ModelHandle ) ;

		// `Ώۂ𗠉ʂɕύX( `Ώ1͉ )
		SetRenderTargetToShader( 0, DX_SCREEN_BACK ) ;
		SetRenderTargetToShader( 1, -1 ) ;

		// SSAOtB^[
		GraphFilterBlt(
			NormalScreenHandle,				// ϊƂĖ@obt@w
			OutputScreenHandle,				// o͐obt@̎w
			DX_GRAPH_FILTER_SSAO,
			ColorScreenHandle,				// J[obt@w
			( float )KernelRadius,			// Օ𒲂ׂ͈
			( float )MinDistance * 0.001f,	// Օ肷ŏ[xl
			( float )MaxDistance * 0.001f,	// Օ肷ő[xl
			( float )Strength    * 0.1f,	// Օ̉e̋
			GetColor( 0,0,0 ),				// IN[WJ[
			( float )OcclusionPower * 0.1f	// IN[WJ[̋
		) ;

		// SSAOtB^[|ʂʂɕ`
		SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 255 );
		DrawGraph( 0, 0, OutputScreenHandle, FALSE ) ;

		// p[^ʂɕ\
		DrawFormatString( 0,  0, GetColor( 255,255,255 ), "A/ZL[  KernelRadius    :%f", ( float )KernelRadius ) ;
		DrawFormatString( 0, 16, GetColor( 255,255,255 ), "S/XL[  MinDistance     :%f", ( float )MinDistance    * 0.001f ) ;
		DrawFormatString( 0, 32, GetColor( 255,255,255 ), "D/CL[  MaxDistance     :%f", ( float )MaxDistance    * 0.001f ) ;
		DrawFormatString( 0, 48, GetColor( 255,255,255 ), "F/VL[  Strength        :%f", ( float )Strength       * 0.1f ) ;
		DrawFormatString( 0, 64, GetColor( 255,255,255 ), "G/BL[  OcclusionPower  :%f", ( float )OcclusionPower * 0.1f ) ;

		// L[ɂp[^̑
		switch( GetInputChar( TRUE ) )
		{
		case 'a': KernelRadius++; break;
		case 'z': if( KernelRadius > 0 ) KernelRadius--; break;

		case 's': MinDistance++; break;
		case 'x': if( MinDistance > 0 ) MinDistance--; break;

		case 'd': MaxDistance++; break;
		case 'c': if( MaxDistance > 0 ) MaxDistance--; break;

		case 'f': Strength++; break;
		case 'v': if( Strength > 0 ) Strength--; break;

		case 'g': OcclusionPower++; break;
		case 'b': if( OcclusionPower > 0 ) OcclusionPower--; break;
		}

		// ʂ̓e\ʂɔf
		ScreenFlip() ;
	}

	// cwCǔn
	DxLib_End() ;

	// \tg̏I
	return 0 ;
}
